package com.engine.organization.entity.logview.vo;

import com.cloudstore.eccom.pc.table.WeaTableType;
import com.engine.organization.annotation.*;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Date;

/**
 * @author:dxfeng
 * @createTime: 2022/07/05
 * @version: 1.0
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@OrganizationTable(pageId = "caef4d3e-fc3d-11ec-a203-00e04c680716",
        fields = "t.id, t.operator_name, t.create_time, t.operate_type, t.client_ip, t.operate_module_name,t.operate_desc",
        fromSql = "FROM hr_log t ",
        primarykey = "id",
        tableType = WeaTableType.NONE
)
public class LogViewVO {

    @OrganizationTableColumn(text = "操作时间", width = "16%", column = "create_time", transmethod = "com.engine.organization.transmethod.StaffPlanTransMethod.getFormatDateString")
    private Date createTime;

    @OrganizationTableColumn(text = "操作者", width = "16%", column = "operator_name")
    private String operator;

    @OrganizationTableColumn(text = "操作类型", width = "16%", column = "operate_type", transmethod = "com.engine.organization.transmethod.LogViewTransMethod.getOperateType")
    private String operateType;

    @OrganizationTableColumn(text = "操作描述", width = "16%", column = "operate_desc")
    private String operateDesc;

    @OrganizationTableColumn(text = "所属模块", width = "16%", column = "operate_module_name")
    private String operateModuleName;

    @OrganizationTableColumn(text = "修改详情", width = "16%")
    private String showDetail;

    @OrganizationTableColumn(text = "操作IP", width = "16%", column = "client_ip")
    private String clientIp;

}
