package com.engine.organization.service.impl;

import com.engine.core.impl.Service;
import com.engine.organization.entity.hrmresource.param.HrmResourceImportParam;
import com.engine.organization.service.ImportCommonService;
import com.engine.organization.util.saveimport.HrmResourceImportAdaptUtil;
import com.engine.organization.util.saveimport.HrmResourceImportProcessUtil;
import com.engine.organization.util.saveimport.SaveImportProcessUtil;
import weaver.file.FileUploadToPath;
import weaver.general.BaseBean;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.systeminfo.SystemEnv;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author:dxfeng
 * @createTime: 2022/06/29
 * @version: 1.0
 */
public class ImportCommonServiceImpl extends Service implements ImportCommonService {

    @Override
    public Map<String, Object> saveImportResource(Map<String, Object> params, HttpServletRequest request) {

        Map<String, Object> returnMap = new HashMap<>();
        try {
            String keyField = (String) params.get("keyField");
            switch (keyField) {
                case "workcode":
                    params.put("keyField","work_code");
                    break;
                case "lastname":
                    params.put("keyField","last_name");
                    break;
                case "loginid":
                    params.put("keyField","login_id");
                    break;
                default:
                    break;

            }
            /*综合考虑多数据源后，实现通过配置文件配置适配器和解析类*/
            List<Object> lsErrorInfo = new ArrayList<>();
            HrmResourceImportAdaptUtil importAdaptUtil = new HrmResourceImportAdaptUtil();
            FileUploadToPath fu = new FileUploadToPath(request);
            int language = this.user.getLanguage();
            importAdaptUtil.setUserlanguage(language);
            List<String> errorInfo = importAdaptUtil.creatImportMap(fu);
            //如果读取数据和验证模板没有发生错误
            if (errorInfo.isEmpty()) {
                Map<String, HrmResourceImportParam> hrMap = importAdaptUtil.getHrmImportMap();
                HrmResourceImportProcessUtil importProcessUtil = new HrmResourceImportProcessUtil();
                importProcessUtil.init(request);
                importProcessUtil.processMap(hrMap);
            } else {
                Map<String, Object> error;
                for (String s : errorInfo) {
                    error = new HashMap<>();
                    error.put("message", Util.null2String(s));
                    lsErrorInfo.add(error);
                }
            }
            returnMap.put("errorInfo", lsErrorInfo);
            returnMap.put("status", "1");
        } catch (Exception e) {
            returnMap.put("status", "-1");
            returnMap.put("message", e.getMessage());
        }
        return returnMap;
    }

    @Override
    public Map<String, Object> saveImport(Map<String, Object> params, HttpServletRequest request, User user) {
        Map<String, Object> returnMap = new HashMap<>();
        request.getSession(true).setAttribute("importBaseCreater", user);
        try {
            List<Object> lsErrorInfo = new ArrayList<>();
            SaveImportProcessUtil importProcessUtil = new SaveImportProcessUtil();
            List<String> errorInfo = importProcessUtil.importXls(request);
            if (errorInfo != null && !errorInfo.isEmpty()) {
                Map<String, Object> error;
                for (String s : errorInfo) {
                    error = new HashMap<>();
                    error.put("message", Util.null2String(s));
                    lsErrorInfo.add(error);
                }
            }
            returnMap.put("errorInfo", lsErrorInfo);
            returnMap.put("status", "1");
            returnMap.put("message", SystemEnv.getHtmlLabelName(24645, user.getLanguage()));
        } catch (Exception e) {
            new BaseBean().writeLog("导入基础数据失败：" + e);
            returnMap.put("status", "-1");
            returnMap.put("message", e.getMessage());
        }
        returnMap.put("pid", request.getSession(true).getAttribute("importExcelPid"));
        return returnMap;
    }
}
