package com.engine.organization.util.saveimport;

import com.alibaba.fastjson.JSONObject;
import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.hrm.entity.RuleCodeType;
import com.engine.hrm.service.ImportLogService;
import com.engine.hrm.service.impl.ImportLogServiceImpl;
import com.engine.hrm.util.CodeRuleManager;
import com.engine.hrm.util.HrmWeakPasswordUtil;
import com.engine.hrm.util.face.HrmFaceCheckManager;
import com.engine.hrm.util.face.ValidateFieldManager;
import com.engine.hrm.util.face.bean.CheckItemBean;
import com.engine.organization.entity.company.po.CompPO;
import com.engine.organization.entity.department.po.DepartmentPO;
import com.engine.organization.entity.extend.param.ExtendInfoParams;
import com.engine.organization.entity.hrmresource.param.HrmResourceImportParam;
import com.engine.organization.entity.hrmresource.po.HrmResourcePO;
import com.engine.organization.entity.job.po.JobPO;
import com.engine.organization.entity.postion.po.PostInfoPO;
import com.engine.organization.entity.postion.po.PostPO;
import com.engine.organization.mapper.comp.CompMapper;
import com.engine.organization.mapper.department.DepartmentMapper;
import com.engine.organization.mapper.extend.ExtMapper;
import com.engine.organization.mapper.hrmresource.HrmResourceMapper;
import com.engine.organization.mapper.hrmresource.SystemDataMapper;
import com.engine.organization.mapper.job.JobMapper;
import com.engine.organization.mapper.post.PostInfoMapper;
import com.engine.organization.mapper.post.PostMapper;
import com.engine.organization.util.PageInfoSortUtil;
import com.engine.organization.util.db.MapperProxyFactory;
import ln.LN;
import org.apache.commons.collections.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import weaver.common.DateUtil;
import weaver.common.StringUtil;
import weaver.conn.RecordSet;
import weaver.general.BaseBean;
import weaver.general.PasswordUtil;
import weaver.general.Util;
import weaver.hrm.User;
import weaver.hrm.definedfield.HrmFieldManager;
import weaver.hrm.passwordprotection.manager.HrmResourceManager;
import weaver.hrm.settings.ChgPasswdReminder;
import weaver.hrm.settings.RemindSettings;
import weaver.join.hrm.in.ImportLog;
import weaver.join.hrm.in.processImpl.HrmTlevelManager;
import weaver.systeminfo.SystemEnv;

import javax.servlet.http.HttpServletRequest;
import java.lang.reflect.Field;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author:dxfeng
 * @createTime: 2022/06/30
 * @version: 1.0
 */
public class HrmResourceImportProcessUtil {


    private final Map<String, Integer> keyMap = new HashMap<>();           //看数据库是否有重复，将数据库现有的数据查出<id,workcode_lastname>

    private final Map<String, Integer> certificateNums = new HashMap<>();//已存在的身份证

    Map<String, Map<String, String>> checkInfos = new HashMap<>();

    private final String[] checkKeys = new String[]{"login_id", "work_code"};

    private final String date = new SimpleDateFormat("yyyy-MM-dd").format(new Date());

    private final int userlanguage = 7;   //登录语言

    LN license = new LN();           //license

    String keyField = "";
    String operateType = "";

    private int scCount = 0;

    private HrmResourceImportParam hrmResourceImportParam = null;

    private String multilanguage;

    private Map<String, Integer> sysLanguage = null;

    private Map<String, Integer> jobcallMap = null;
    private Map<String, Integer> locationMap = null;
    private Map<String, Integer> usekindMap = null;
    private Map<String, Integer> educationlevelMap = null;

    private int cnLanguageId = 7;

    private User user;
    private int pId = 0;
    private int rowNum = 0;

    //判断弱密码
    private HrmWeakPasswordUtil hrmWeakPasswordUtil;


    private HrmResourceMapper getResourceMapper() {
        return MapperProxyFactory.getProxy(HrmResourceMapper.class);
    }

    private CompMapper getCompMapper() {
        return MapperProxyFactory.getProxy(CompMapper.class);
    }

    private DepartmentMapper getDepartmentMapper() {
        return MapperProxyFactory.getProxy(DepartmentMapper.class);
    }

    private JobMapper getJobMapper() {
        return MapperProxyFactory.getProxy(JobMapper.class);
    }

    private PostInfoMapper getPostInfoMapper() {
        return MapperProxyFactory.getProxy(PostInfoMapper.class);
    }

    private PostMapper getPostMapper() {
        return MapperProxyFactory.getProxy(PostMapper.class);

    }

    private SystemDataMapper getSystemDataMapper() {
        return MapperProxyFactory.getProxy(SystemDataMapper.class);
    }

    private ExtMapper getExtMapper() {
        return MapperProxyFactory.getProxy(ExtMapper.class);
    }

    public void setUser(User user) {
        this.user = user;
    }

    public void init(HttpServletRequest request) {
        Map<String, Object> retmap;
        try {
            this.user = (User) request.getSession(true).getAttribute("weaver_user@bean");
            this.keyField = Util.null2String(request.getParameter("keyField"));
            switch (keyField) {
                case "workcode":
                    keyField = "work_code";
                    break;
                case "lastname":
                    keyField = "last_name";
                    break;
                case "loginid":
                    keyField = "login_id";
                    break;
                default:
                    break;

            }
            this.operateType = Util.null2String(request.getParameter("operateType"));

            ImportLogService importLogService = ServiceUtil.getService(ImportLogServiceImpl.class, user);
            Map<String, Object> params = ParamUtil.request2Map(request);
            params.put("operateType", this.operateType);
            retmap = importLogService.saveImportLog(params, request, user);
            if (Util.null2String(retmap.get("status")).equals("1")) {
                this.pId = Util.getIntValue(Util.null2String(retmap.get("pId")));
                request.getSession(true).setAttribute("hrmresourcePId", this.pId);
            }

            final int F_Y = 0;
            final int F_N = 1;
            LN license = new LN();
            license.InLicense();
            int type = StringUtil.parseToInt(license.getScType(), F_N);
            scCount = StringUtil.parseToInt(license.getScCount(), 0);
            scCount = type == F_Y ? (Math.max(scCount, 0)) : 0;

            JSONObject sysLanguageByLicense = getSystemDataMapper().getSysLanguageByLicense();
            if (null != sysLanguageByLicense) {
                multilanguage = sysLanguageByLicense.getString("multilanguage");
                cnLanguageId = sysLanguageByLicense.getInteger("cnLanguageId");
            }


            sysLanguage = new HashMap<>();
            List<JSONObject> sysLanguageByActivables = getSystemDataMapper().getSysLanguageByActivable();
            for (JSONObject sysLanguageByActivable : sysLanguageByActivables) {
                sysLanguage.put(sysLanguageByActivable.getString("language"), sysLanguageByActivable.getInteger("id"));
            }
            educationlevelMap = new HashMap<>();
            List<JSONObject> hrmEducationLevelDatas = getSystemDataMapper().getHrmEducationLevelData();
            for (JSONObject hrmEducationLevelData : hrmEducationLevelDatas) {
                educationlevelMap.put(hrmEducationLevelData.getString("name"), hrmEducationLevelData.getInteger("id"));
            }

            jobcallMap = new HashMap<>();
            List<JSONObject> hrmJobCallDatas = getSystemDataMapper().getHrmJobCallData();
            for (JSONObject hrmJobCallData : hrmJobCallDatas) {
                jobcallMap.put(hrmJobCallData.getString("name"), hrmJobCallData.getInteger("id"));
            }

            locationMap = new HashMap<>();
            List<JSONObject> hrmLocations = getSystemDataMapper().getHrmLocationsByCountryId();
            for (JSONObject hrmLocation : hrmLocations) {
                locationMap.put(hrmLocation.getString("locationname"), hrmLocation.getInteger("id"));
            }

            usekindMap = new HashMap<>();
            List<JSONObject> hrmUseKindDatas = getSystemDataMapper().getHrmUseKindData();
            for (JSONObject hrmUseKindData : hrmUseKindDatas) {
                usekindMap.put(hrmUseKindData.getString("name"), hrmUseKindData.getInteger("id"));
            }
        } catch (Exception e) {
            new BaseBean().writeLog(e);
        }
    }

    /**
     * 对人员数据进行解析，并添加到数据库
     *
     * @param hrMap 人员数据Map集合
     */
    public void processMap(Map<String, HrmResourceImportParam> hrMap) {//增加同步锁，防止同时多次调用
        List<ImportLog> resultList = new ArrayList<>();          //导入结果
        RecordSet recordSet = new RecordSet();
        ImportLogService importLogService = ServiceUtil.getService(ImportLogServiceImpl.class, user);
        try {
            String subCompanyName = "";      //分部名称
            String departmentName = "";      //部门名称
            long companyId = 0L;           // 分部Id
            long departmentId = 0L;            // 部门id
            String key;                   // workcode_lastname 组合
            getKeyMap(keyField);             //获取重复性验证字段Map
            Long id;

            Set<String> keySet = hrMap.keySet();
            Object[] keyArray = keySet.toArray();

            Class<HrmResourcePO> resourcePOClass = HrmResourcePO.class;
            Class<HrmResourceImportParam> importParamClass = HrmResourceImportParam.class;

            String field = "work_code,login_id,last_name,sex,account_type,belong_to,company_id,department_id,job_activity,job_title,job_call,job_level,job_group_id,job_activity_desc,status,system_language,resource_image_id,messager_url,location_id,manager_id,assistant_id,mobile,telephone,mobile_call,fax,email,workroom,pass_word,sec_level,birthday,folk,native_place,reg_resident_place,certificate_num,marital_status,policy,be_member_date,be_party_date,islabouunion,degree,health_info,education_level,height,weight,use_kind,start_date,end_date,probation_end_date,resident_place,home_address,temp_resident_number,company_start_date,work_start_date,accum_fund_account,account_name,bank_id,account_id,show_order,classification,company_work_year,work_year";

            String[] fields = field.split(",");

            int createrid = 1; // 创建者id
            // 最后修改者id
            if (user != null) {
                createrid = user.getUID();
            }

            ChgPasswdReminder reminder = new ChgPasswdReminder();
            RemindSettings settings = reminder.getRemindSettings();
            //判断是否启用【启用初始密码】
            //是否启用初始密码：false-不启用初始密码、true-启用初始密码
            boolean defaultPasswordEnable = Util.null2String(settings.getDefaultPasswordEnable()).equals("1");
            //初始密码
            //初始密码
            String defaultPassword = Util.null2String(settings.getDefaultPassword());
            //判断是否启用【弱密码禁止保存】
            //弱密码禁止保存：false-允许保存弱密码、true-不允许保存弱密码
            boolean weakPasswordDisable = Util.null2String(settings.getWeakPasswordDisable()).equals("1");
            try {
                //判断是否为弱密码
                hrmWeakPasswordUtil = new HrmWeakPasswordUtil();
            } catch (Exception e) {
                new BaseBean().writeLog(e);
            }

            String obj;
            HrmResourcePO hrmResourcePO;
            for (Object o : keyArray) {
                obj = o.toString();
                hrmResourceImportParam = hrMap.get(obj);
                key = obj;
                hrmResourcePO = new HrmResourcePO();
                this.rowNum++;
                try {  // 异常处理

                    if (operateType.equals("add")) {
                        if (keyMap.get(key) != null) {
                            resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(83520, userlanguage)));
                            continue;
                        }

                        if (this.checkInfo(hrmResourceImportParam, resultList)) {
                            continue;
                        }
                        if (hrmResourceImportParam.getAccount_type() == null || "".equalsIgnoreCase(Util.null2String(hrmResourceImportParam.getAccount_type()))) {
                            if (StringUtil.isNotNull(hrmResourceImportParam.getCertificate_num()) && certificateNums.get(StringUtil.vString(hrmResourceImportParam.getCertificate_num())) != null) {
                                resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(83521, userlanguage)));
                                continue;
                            }
                        } else {
                            if (hrmResourceImportParam.getAccount_type() != null && !"".equals(hrmResourceImportParam.getAccount_type())) {
                                if ("主账号".equals(hrmResourceImportParam.getAccount_type())) {
                                    if (StringUtil.isNotNull(hrmResourceImportParam.getCertificate_num()) && certificateNums.get(StringUtil.vString(hrmResourceImportParam.getCertificate_num())) != null) {
                                        resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(83521, userlanguage)));
                                        continue;
                                    }
                                }
                            }
                        }

                        //添加人员信息 license 人员上限判断

                        if (keyMap.get(key) == null && StringUtils.isNotBlank(hrmResourceImportParam.getLogin_id()) && ("主账号".equals(hrmResourceImportParam.getAccount_type()) || StringUtils.isBlank(hrmResourceImportParam.getAccount_type())) && "正式,试用,临时,试用延期".contains(Util.null2String(hrmResourceImportParam.getStatus()))) {
                            license.reloadLicenseInfo();
                            if (license.CkHrmnum() >= 0) {
                                resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(83522, userlanguage)));
                                continue;
                            }
                        }
                        // 分部Id
                        String subCompanyNames = hrmResourceImportParam.getCompany_id() + "";
                        String tempSubCompanyName = "";
                        if (subCompanyNames != null) {
                            if (!subCompanyNames.equals(subCompanyName)) {
                                tempSubCompanyName = subCompanyName;
                                subCompanyName = subCompanyNames;
                                companyId = getSubCompanyId(subCompanyName);
                            }
                            if (companyId == -9) {
                                resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getErrorMsgName(56, userlanguage)));
                                continue;
                            }
                            if (companyId == -2) {
                                resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(126274, userlanguage)));
                                continue;
                            }
                            if (companyId == -1) {
                                resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(83524, userlanguage)));
                                continue;
                            }
                            if (StringUtil.parseToInt(license.getConcurrentFlag(), 0) != 1) {
                                if (new HrmResourceManager().noMore(String.valueOf(companyId))) {
                                    resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(83525, userlanguage)));
                                    continue;
                                }
                            }
                            companyId = 0 == companyId ? null : companyId;
                            hrmResourcePO.setCompanyId(companyId);
                        } else {
                            resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(83526, userlanguage)));
                            continue;
                        }

                        // 部门id
                        String departmentNames = hrmResourceImportParam.getDepartment_id();
                        if (departmentNames != null) {
                            if (!subCompanyNames.equals(tempSubCompanyName) || !departmentNames.equals(departmentName)) {
                                departmentName = departmentNames;
                                departmentId = getDeptId(departmentName, companyId);
                            }
                            if (departmentId == -2) {
                                resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(126275, userlanguage)));
                                continue;
                            }
                            hrmResourcePO.setDepartmentId(departmentId);
                        } else {
                            resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(83527, userlanguage)));
                            continue;
                        }

                        if (hrmResourceImportParam.getLast_name() == null) {
                            resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(83529, userlanguage)));
                            continue;
                        }

                        //主账号id-sunjsh
                        if (hrmResourceImportParam.getAccount_type() != null && !"".equals(hrmResourceImportParam.getAccount_type())) {
                            if ("主账号".equals(hrmResourceImportParam.getAccount_type())) {
                                hrmResourcePO.setBelongTo(-1L);
                                hrmResourcePO.setAccountType(0);
                            } else if ("次账号".equals(hrmResourceImportParam.getAccount_type())) {
                                if (hrmResourceImportParam.getBelong_to() != null && !"".equals(hrmResourceImportParam.getBelong_to().trim())) {
                                    long belongTo = getBelongId(hrmResourceImportParam.getBelong_to(), keyField);
                                    hrmResourcePO.setBelongTo(belongTo);
                                    if (!hrmResourceImportParam.getBelong_to().equals("") && belongTo == 0) {
                                        resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(131279, userlanguage)));
                                        continue;
                                    } else {
                                        hrmResourcePO.setAccountType(1);
                                    }
                                } else {
                                    resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(131279, userlanguage)));
                                    continue;
                                }
                            } else {
                                hrmResourcePO.setBelongTo(-1L);
                                hrmResourcePO.setAccountType(0);
                            }
                        } else if (hrmResourceImportParam.getBelong_to() != null && !"".equals(hrmResourceImportParam.getBelong_to().trim())) {
                            long belongTo = getBelongId(hrmResourceImportParam.getBelong_to(), keyField);
                            hrmResourcePO.setBelongTo(belongTo);
                            if (!hrmResourceImportParam.getBelong_to().equals("") && belongTo == 0) {
                                resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(131279, userlanguage)));
                                continue;
                            } else {
                                hrmResourcePO.setAccountType(1);
                            }
                        } else {
                            hrmResourcePO.setBelongTo(-1L);
                            hrmResourcePO.setAccountType(0);
                        }

                        // 岗位id
                        if (hrmResourceImportParam.getJob_title() != null && hrmResourceImportParam.getJob_activity() != null && hrmResourceImportParam.getJob_group_id() != null) {
                            String jobNames = hrmResourceImportParam.getJob_title();
                            hrmResourcePO.setJobTitle(getJobTitles(companyId, departmentId, jobNames));
                        } else {
                            resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(83531, userlanguage)));
                            continue;
                        }

                        //上级id
                        if (hrmResourceImportParam.getManager_id() != null) {
                            int managerid = getManagerId(hrmResourceImportParam.getManager_id(), keyField);
                            hrmResourcePO.setManagerId(0 == managerid ? null : managerid);
                            //如果vo.getManagerid()有值，但manageid未找到，说明填写有误
                            if (!hrmResourceImportParam.getManager_id().equals("") && managerid == 0) {
                                resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(83532, userlanguage)));
                                continue;
                            }
                        } else {
                            hrmResourcePO.setManagerId(null);
                        }

                        // 助理id
                        if (hrmResourceImportParam.getAssistant_id() != null) {
                            int assistantId = getAssistantId(hrmResourceImportParam.getAssistant_id(), keyField);
                            hrmResourcePO.setAssistantId(assistantId);
                            if (!hrmResourceImportParam.getAssistant_id().equals("") && assistantId == 0) {
                                resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(24678, userlanguage)));
                                continue;
                            }
                        }

                        // 办公地点
                        if (hrmResourceImportParam.getLocation_id() != null) {
                            hrmResourcePO.setLocationId(getLocationId(hrmResourceImportParam.getLocation_id()));
                        } else {
                            resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(83533, userlanguage)));
                            continue;
                        }

                        //邮箱-sunjsh
                        if (hrmResourceImportParam.getEmail() != null) {
                            if (!"".equals(hrmResourceImportParam.getEmail().trim()) && hrmResourceImportParam.getEmail().contains("*")) {
                                hrmResourceImportParam.setEmail(null);
                            } else if ("".equals(hrmResourceImportParam.getEmail().trim())) {
                                hrmResourcePO.setEmail("");
                            } else {
                                Pattern pattern = Pattern.compile("^([a-zA-Z\\d_\\-.]+)@((\\[\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}\\.)|(([a-zA-Z\\d\\-]+\\.)+))([a-zA-Z]{2,4}|\\d{1,3})(]?)$");
                                Matcher matcher = pattern.matcher(hrmResourceImportParam.getEmail());
                                if (!matcher.matches()) {
                                    resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(24570, userlanguage)));
                                    continue;
                                } else {
                                    hrmResourcePO.setEmail(hrmResourceImportParam.getEmail());
                                }
                            }
                        }

                        //mobile-sunjsh
                        if (hrmResourceImportParam.getMobile() != null) {
                            if ("".equals(hrmResourceImportParam.getMobile().trim()) || (!"".equals(hrmResourceImportParam.getMobile().trim()) && hrmResourceImportParam.getMobile().contains("*")))
                                hrmResourceImportParam.setMobile(null);
                        } else hrmResourcePO.setMobile("");

                        //工资银行-sunjsh
                        if (hrmResourceImportParam.getBank_id() != null && !"".equals(hrmResourceImportParam.getBank_id())) {
                            org.json.JSONObject jsonObject = new org.json.JSONObject();
                            jsonObject.put("fieldid", 0);
                            jsonObject.put("fieldhtmltype", 3);
                            jsonObject.put("type", 284);
                            jsonObject.put("dmlurl", "");
                            jsonObject.put("fieldvalue", hrmResourceImportParam.getBank_id());

                            String fieldvalue = HrmFieldManager.getReallyFieldvalue(jsonObject);
                            if (!"".equals(fieldvalue)) {
                                hrmResourcePO.setBankId(new Integer(fieldvalue));
                            } else {
                                hrmResourcePO.setBankId(this.getBankId(hrmResourceImportParam.getBank_id()));
                            }
                        }

                        //sunjsh-入职日期
                        if (hrmResourceImportParam.getCompany_start_date() != null && !"".equals(hrmResourceImportParam.getCompany_start_date())) {
                            hrmResourcePO.setCompanyStartDate(hrmResourceImportParam.getCompany_start_date());
                        }

                        //sunjsh-参加工作日期
                        if (hrmResourceImportParam.getWork_start_date() != null && !"".equals(hrmResourceImportParam.getWork_start_date())) {
                            hrmResourcePO.setWorkStartDate(hrmResourceImportParam.getWork_start_date());
                        }
                        // 性别，为空或其他情况统一为0(男)
                        String sex = "女".equals(hrmResourceImportParam.getSex()) ? "1" : "0";
                        hrmResourcePO.setSex(sex);

                        // 职称
                        if (hrmResourceImportParam.getJob_call() != null) {
                            int jobcall = getJobCall(hrmResourceImportParam.getJob_call());
                            hrmResourcePO.setJobCall(jobcall);
                        }
                        // 系统语言，默认简体中文
                        if (hrmResourceImportParam.getSystem_language() != null) {
                            int systemlanguage = getSystemLanguage(hrmResourceImportParam.getSystem_language());

                            if (systemlanguage == -1) {    //只能选择简体中文|Englisth|繁体中文
                                resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(518929, userlanguage)));
                                continue;
                            }
                            if (systemlanguage == 0) {    //系统不支持多语言
                                resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(84810, userlanguage)));
                                continue;
                            }
                            hrmResourcePO.setSystemLanguage(systemlanguage);
                        } else {
                            hrmResourcePO.setSystemLanguage(7);
                        }

                        // 婚姻状况，如果不是以下选项，则默认为未婚
                        String maritalStatus = "已婚".equals(hrmResourceImportParam.getMarital_status()) ? "1" : "离异".equals(hrmResourceImportParam.getMarital_status()) ? "2" : "0";
                        hrmResourcePO.setMaritalStatus(maritalStatus);

                        // 员工状态
                        if (!"".equals(Util.null2String(hrmResourceImportParam.getStatus()))) {
                            int status = getStatus(hrmResourceImportParam.getStatus());
                            hrmResourcePO.setStatus(status);
                        } else {
                            hrmResourcePO.setStatus(1);
                        }

                        // 人员密级
                        if (!"".equals(Util.null2String(hrmResourceImportParam.getClassification()))) {
                            int classification = getClassification(hrmResourceImportParam.getClassification());
                            hrmResourcePO.setClassification(classification);
                        }
                        // 学历
                        if (hrmResourceImportParam.getEducation_level() != null) {
                            int educationLevel = getEducationLevel(hrmResourceImportParam.getEducation_level());
                            hrmResourcePO.setEducationLevel(educationLevel);
                        }

                        // 工会会员,默认为是
                        String islabouunion = "是".equals(hrmResourceImportParam.getIslabouunion()) ? "1" : "0";
                        hrmResourcePO.setIslabouunion(islabouunion);

                        // 健康状况
                        if (hrmResourceImportParam.getHealth_info() != null) {
                            String healthinfo = getHealthInfo(hrmResourceImportParam.getHealth_info());
                            hrmResourcePO.setHealthInfo(healthinfo);
                        } else {
                            hrmResourcePO.setHealthInfo("0");
                        }

                        //安全级别不能大于999
                        if (Util.getIntValue(hrmResourceImportParam.getSec_level(), 0) > 999) {
                            resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(515522, userlanguage)));
                            continue;
                        }
                        //安全级别不能小于-999
                        if (Util.getIntValue(hrmResourceImportParam.getSec_level(), 0) < -999) {
                            resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(515523, userlanguage)));
                            continue;
                        }
                        //安全级别必须是数字
                        if (!Util.null2String(hrmResourceImportParam.getSec_level()).equals("")) {
                            if (Util.getIntValue(hrmResourceImportParam.getSec_level(), -1000) == -1000) {
                                resultList.add(createLog(hrmResourceImportParam, "创建", "失败", "安全级别必须是数字"));
                                continue;
                            } else {
                                hrmResourcePO.setSecLevel(Util.getIntValue(hrmResourceImportParam.getSec_level()));
                            }
                        } else {
                            //安全级别为空时取缓存类中的安全级别
                            hrmResourcePO.setSecLevel(0);
                        }

                        //职级
                        if (isInteger(hrmResourceImportParam.getJob_level())) {
                            // TODO 职级
                            Long jobLevel = hrmResourceImportParam.getJob_level().equals("") ? 0 : Long.parseLong(hrmResourceImportParam.getJob_level());
                            hrmResourcePO.setJobLevel(jobLevel);
                        } else {
                            hrmResourcePO.setJobLevel(0L);
                        }
                        // 职务分类
                        Long jobGroupId = null;
                        if (hrmResourceImportParam.getJob_group_id() != null) {
                            List<PostPO> postPOS = getPostMapper().listByName(hrmResourceImportParam.getJob_group_id());
                            if (CollectionUtils.isNotEmpty(postPOS)) {
                                jobGroupId = postPOS.get(0).getId();
                            } else {
                                PostPO postPO = PostPO.builder()
                                        .postName(hrmResourceImportParam.getJob_group_id())
                                        .creator((long) user.getUID())
                                        .deleteType(0)
                                        .createTime(new Date())
                                        .build();
                                getPostMapper().insertIgnoreNull(postPO);
                                jobGroupId = postPO.getId();
                            }
                            hrmResourcePO.setJobGroupId(jobGroupId);
                        }

                        // 职务
                        if (hrmResourceImportParam.getJob_activity() != null) {
                            if (null == jobGroupId) {
                                resultList.add(createLog(hrmResourceImportParam, "创建", "失败", "职务导入错误，未找到对应职务类别"));
                                continue;
                            }
                            PostInfoPO postInfoPO = getPostInfoMapper().getPostInfoByNameAndPostId(hrmResourceImportParam.getJob_activity(), jobGroupId);
                            if (null == postInfoPO) {
                                postInfoPO = PostInfoPO.builder()
                                        .postInfoNo(hrmResourceImportParam.getJob_activity())
                                        .postInfoName(hrmResourceImportParam.getJob_activity())
                                        .postId(jobGroupId)
                                        .creator((long) user.getUID())
                                        .deleteType(0)
                                        .createTime(new Date())
                                        .build();
                                getPostInfoMapper().insertIgnoreNull(postInfoPO);
                            }
                            hrmResourcePO.setJobActivity(postInfoPO.getId());
                        }

                        //用工性质
                        if (hrmResourceImportParam.getUse_kind() != null) {
                            int useKind = getUseKind(hrmResourceImportParam.getUse_kind());
                            hrmResourcePO.setUseKind(useKind);
                        } else {
                            hrmResourcePO.setUseKind(0);
                        }


                        // 手机 办公电话
                        CheckItemBean mobileBean = new CheckItemBean("mobile", hrmResourceImportParam.getMobile());
                        ValidateFieldManager.validate(mobileBean);
                        if (!mobileBean.isPass()) {
                            resultList.add(createLog(hrmResourceImportParam, "创建", "失败", mobileBean.getCheckMsg()));
                            continue;
                        }
                        CheckItemBean telephoneBean = new CheckItemBean("telephone", hrmResourceImportParam.getTelephone());
                        ValidateFieldManager.validate(telephoneBean);
                        if (!telephoneBean.isPass()) {
                            resultList.add(createLog(hrmResourceImportParam, "创建", "失败", telephoneBean.getCheckMsg()));
                            continue;
                        }


                        ////id，非自动增长
                        Long maxId = getResourceMapper().getMaxId();
                        id = null == maxId ? 1 : maxId + 1;
                        hrmResourcePO.setId(id);


                        //密码 加密
                        String password_tmp = Util.null2String(hrmResourceImportParam.getPass_word()).trim();
                        if ("".equals(password_tmp)) {
                            password_tmp = "1";
                            //人员导入文件中，将密码这一列删除或者密码这一列存在，但是不填写都默认为初始密码
                            if (defaultPasswordEnable) {
                                if (!defaultPassword.equals("")) {
                                    if (weakPasswordDisable && this.hrmWeakPasswordUtil.isWeakPsd(defaultPassword)) {
                                        resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(515436, userlanguage)));
                                        continue;
                                    } else {
                                        password_tmp = defaultPassword;
                                    }
                                } else {
                                    resultList.add(createLog(hrmResourceImportParam, "创建", "失败", SystemEnv.getHtmlLabelName(516347, userlanguage)));
                                    continue;
                                }
                            }
                        }
                        // 显示顺序
                        if (null != hrmResourceImportParam.getShow_order()) {
                            hrmResourcePO.setShowOrder(hrmResourceImportParam.getShow_order());
                        } else {
                            hrmResourcePO.setShowOrder(id.intValue());
                        }

                        String[] encrypts = PasswordUtil.encrypt(password_tmp);
                        HrmFaceCheckManager.setUserPassowrd(id + "", password_tmp);

                        String password = encrypts[0];
                        hrmResourcePO.setPassWord(password);

                        boolean flag = true;

                        /*添加人员信息*/
                        Map<String, Object> resourceParams = new HashMap<>();

                        String workCode = hrmResourceImportParam.getWork_code();
                        workCode = CodeRuleManager.getCodeRuleManager().generateRuleCode(RuleCodeType.USER, workCode);
                        hrmResourceImportParam.setWork_code(workCode);

                        for (String s : fields) {
                            Field resourcePOClassField = resourcePOClass.getDeclaredField(PageInfoSortUtil.underlineToHump(s));
                            Field paramClassDeclaredField = importParamClass.getDeclaredField(s);

                            String hrmFieldType = resourcePOClassField.getType().getName();
                            String voFieldType = paramClassDeclaredField.getType().getName();

                            resourcePOClassField.setAccessible(true);
                            paramClassDeclaredField.setAccessible(true);

                            //首先取hrm对象中的数据，没有去vo中的
                            boolean isNumber = hrmFieldType.endsWith("Long") || hrmFieldType.endsWith("Integer") || hrmFieldType.endsWith("Short") || hrmFieldType.endsWith("Float");
                            if (resourcePOClassField.get(hrmResourcePO) != null) {
                                if (hrmFieldType.endsWith("String")) {
                                    resourceParams.put(s, resourcePOClassField.get(hrmResourcePO));
                                } else if (isNumber) {
                                    String insertValueStr = Util.null2String(resourcePOClassField.get(hrmResourcePO));
                                    if ("".equals(insertValueStr) && recordSet.getDBType().equalsIgnoreCase("postgresql")) {
                                        resourceParams.put(s, null);
                                    } else {
                                        resourceParams.put(s, resourcePOClassField.get(hrmResourcePO));
                                    }
                                }
                            } else if (paramClassDeclaredField.get(hrmResourceImportParam) != null) {
                                if (voFieldType.endsWith("String")) {
                                    if (Util.null2String(paramClassDeclaredField.get(hrmResourceImportParam)).equals("")) {
                                        resourceParams.put(s, null);
                                    } else {
                                        resourceParams.put(s, paramClassDeclaredField.get(hrmResourceImportParam));
                                    }
                                } else if (isNumber) {
                                    String insertValueStr = Util.null2String(paramClassDeclaredField.get(hrmResourceImportParam));
                                    if ("".equals(insertValueStr) && recordSet.getDBType().equalsIgnoreCase("postgresql")) {
                                        resourceParams.put(s, null);
                                    } else {
                                        resourceParams.put(s, paramClassDeclaredField.get(hrmResourceImportParam));
                                    }

                                }
                            }
                        }
                        resourceParams.put("creator", createrid);
                        resourceParams.put("delete_type", 0);
                        resourceParams.put("create_time", date);
                        ExtendInfoParams infoParams = ExtendInfoParams.builder().tableName("jcl_org_hrmresource").params(resourceParams).build();
                        int insertCount = getExtMapper().insertExt(infoParams);
                        //添加人员信息
                        if (insertCount != 1) {
                            flag = false;
                        }

                        /*写日志*/
                        if (flag) {
                            resultList.add(createLog(hrmResourceImportParam, "创建", "成功", ""));
                        } else {
                            resultList.add(createLog(hrmResourceImportParam, "创建", "失败", "系统错误，请联系管理员"));
                        }

                    } else {    //更新人员
                        if (keyMap.get(key) == null) {
                            resultList.add(createLog(hrmResourceImportParam, "更新", "失败", SystemEnv.getHtmlLabelName(83535, userlanguage)));
                            continue;
                        }

                        hrmResourceImportParam.setId(Long.parseLong(keyMap.get(key).toString()));//设置id
                        if (this.checkInfo(hrmResourceImportParam, resultList)) {
                            continue;
                        }

                        if (hrmResourceImportParam.getAccount_type() == null || "".equalsIgnoreCase(Util.null2String(hrmResourceImportParam.getAccount_type()))) {
                            if (StringUtil.isNotNull(hrmResourceImportParam.getCertificate_num()) && certificateNums.get(StringUtil.vString(hrmResourceImportParam.getCertificate_num())) != null) {
                                if (StringUtil.parseToInt(String.valueOf(keyMap.get(key))) != StringUtil.parseToInt(String.valueOf(certificateNums.get(StringUtil.vString(hrmResourceImportParam.getCertificate_num()))))) {
                                    resultList.add(createLog(hrmResourceImportParam, "更新", "失败", SystemEnv.getHtmlLabelName(83521, userlanguage)));
                                    continue;
                                }
                            }
                        } else {
                            if (hrmResourceImportParam.getAccount_type() != null && !"".equals(hrmResourceImportParam.getAccount_type())) {
                                if ("主账号".equals(hrmResourceImportParam.getAccount_type())) {
                                    if (StringUtil.isNotNull(hrmResourceImportParam.getCertificate_num()) && certificateNums.get(StringUtil.vString(hrmResourceImportParam.getCertificate_num())) != null) {
                                        if (StringUtil.parseToInt(String.valueOf(keyMap.get(key))) != StringUtil.parseToInt(String.valueOf(certificateNums.get(StringUtil.vString(hrmResourceImportParam.getCertificate_num()))))) {
                                            resultList.add(createLog(hrmResourceImportParam, "更新", "失败", SystemEnv.getHtmlLabelName(83521, userlanguage)));
                                            continue;
                                        }
                                    }
                                }
                            }
                        }

                        String hrmId = String.valueOf(keyMap.get(key));

                        //分部id
                        String subCompanyNames = hrmResourceImportParam.getCompany_id();
                        boolean issameSub = true;
                        if (!"".equals(Util.null2String(subCompanyNames))) {
                            if (!subCompanyNames.equals(subCompanyName)) {
                                subCompanyName = subCompanyNames;
                                companyId = getSubCompanyId(subCompanyName);
                                issameSub = false;
                            }
                            if (companyId == -9) {
                                resultList.add(createLog(hrmResourceImportParam, "更新", "失败", SystemEnv.getErrorMsgName(56, userlanguage)));
                                continue;
                            }
                            if (companyId == -2) {
                                resultList.add(createLog(hrmResourceImportParam, "更新", "失败", SystemEnv.getHtmlLabelName(126274, userlanguage)));
                                continue;
                            }
                            if (companyId == 0 || companyId == -1) {
                                resultList.add(createLog(hrmResourceImportParam, "更新", "失败", companyId == 0 ? SystemEnv.getHtmlLabelName(83536, userlanguage) : SystemEnv.getHtmlLabelName(83524, userlanguage)));
                                continue;
                            }

                            //qc139575 在验证并发非并发之前需要先CkHrmnum
                            license.CkHrmnum();
                            if (StringUtil.parseToInt(license.getConcurrentFlag(), 0) != 1) {
                                if (!issameSub && new HrmResourceManager().noMore(String.valueOf(companyId))) {
                                    resultList.add(createLog(hrmResourceImportParam, "更新", "失败", SystemEnv.getHtmlLabelName(83525, userlanguage)));
                                    continue;
                                }
                            }
                            companyId = 0 == companyId ? null : companyId;
                            hrmResourcePO.setCompanyId(companyId);
                        }

                        // 部门id
                        String departmentNames = hrmResourceImportParam.getDepartment_id();
                        if (!"".equals(Util.null2String(departmentNames))) {  //部门存在时
                            if (!issameSub || !departmentNames.equals(departmentName)) {
                                departmentName = departmentNames;
                            }
                            departmentId = getDeptId(departmentName, companyId);
                            if (departmentId == 0) {
                                resultList.add(createLog(hrmResourceImportParam, "更新", "失败", SystemEnv.getHtmlLabelName(83537, userlanguage)));
                                continue;
                            }
                            if (departmentId == -2) {
                                resultList.add(createLog(hrmResourceImportParam, "更新", "失败", SystemEnv.getHtmlLabelName(126275, userlanguage)));
                                continue;
                            }
                            hrmResourcePO.setDepartmentId(departmentId);
                        }

                        //主账号id-sunjsh
                        if (hrmResourceImportParam.getAccount_type() != null && !"".equals(hrmResourceImportParam.getAccount_type())) {
                            if ("主账号".equals(hrmResourceImportParam.getAccount_type())) {
                                hrmResourcePO.setBelongTo(-1L);
                                hrmResourcePO.setAccountType(0);
                            } else if ("次账号".equals(hrmResourceImportParam.getAccount_type())) {
                                if (hrmResourceImportParam.getBelong_to() != null && !"".equals(hrmResourceImportParam.getBelong_to().trim())) {
                                    long belongto = getBelongId(hrmResourceImportParam.getBelong_to(), keyField);
                                    hrmResourcePO.setBelongTo(belongto);
                                    if (!hrmResourceImportParam.getBelong_to().equals("") && belongto == 0) {
                                        resultList.add(createLog(hrmResourceImportParam, "更新", "失败", SystemEnv.getHtmlLabelName(131279, userlanguage)));
                                        continue;
                                    } else {
                                        hrmResourcePO.setAccountType(1);
                                    }
                                } else {
                                    resultList.add(createLog(hrmResourceImportParam, "更新", "失败", SystemEnv.getHtmlLabelName(131279, userlanguage)));
                                    continue;
                                }
                            } else {
                                hrmResourcePO.setBelongTo(-1L);
                                hrmResourcePO.setAccountType(0);
                            }
                        } else if (hrmResourceImportParam.getBelong_to() != null && !"".equals(hrmResourceImportParam.getBelong_to().trim())) {
                            long belongto = getBelongId(hrmResourceImportParam.getBelong_to(), keyField);
                            hrmResourcePO.setBelongTo(belongto);
                            if (!hrmResourceImportParam.getBelong_to().equals("") && belongto == 0) {
                                resultList.add(createLog(hrmResourceImportParam, "更新", "失败", SystemEnv.getHtmlLabelName(131279, userlanguage)));
                                continue;
                            } else {
                                hrmResourcePO.setAccountType(1);
                            }
                        }

                        // TODO 岗位id
                        if ("".equals(Util.null2String(hrmResourceImportParam.getJob_title())) && (!"".equals(Util.null2String(hrmResourceImportParam.getJob_activity())) || !"".equals(Util.null2String(hrmResourceImportParam.getJob_group_id())))) {
                            resultList.add(createLog(hrmResourceImportParam, "更新", "失败", SystemEnv.getHtmlLabelName(83544, userlanguage)));
                            continue;
                        }
                        if (!"".equals(Util.null2String(hrmResourceImportParam.getJob_title()))) {
                            String jobNames = hrmResourceImportParam.getJob_title();
                            hrmResourcePO.setJobTitle(getJobTitles(companyId, departmentId, jobNames));
                        }
                        if (Util.getIntValue(hrmId) < 0) {
                            continue;
                        }

                        // 级序列
                        if (!"".equals(Util.null2String(hrmResourceImportParam.getManager_id()))) {
                            int managerid = getManagerId(hrmResourceImportParam.getManager_id(), keyField);
                            //如果vo.getManagerid()有值，但manageid未找到，说明填写有误
                            if (hrmResourceImportParam.getManager_id() != null && !hrmResourceImportParam.getManager_id().equals("") && managerid == 0) {
                                resultList.add(createLog(hrmResourceImportParam, "更新", "失败", SystemEnv.getHtmlLabelName(83532, userlanguage)));
                                continue;
                            }
                            hrmResourcePO.setManagerId(0 == managerid ? null : managerid);
                        } else {
                            hrmResourcePO.setManagerId(null);
                        }
                        // 助理id
                        if (!"".equals(Util.null2String(hrmResourceImportParam.getAssistant_id()))) {
                            int assistantId;
                            assistantId = getAssistantId(hrmResourceImportParam.getAssistant_id(), keyField);
                            if (hrmResourceImportParam.getAssistant_id() != null && !hrmResourceImportParam.getAssistant_id().equals("") && assistantId == 0) {
                                resultList.add(createLog(hrmResourceImportParam, "更新", "失败", SystemEnv.getHtmlLabelName(24678, userlanguage)));
                                continue;
                            }
                            hrmResourcePO.setAssistantId(assistantId);
                        }
                        // 办公地点
                        if (!"".equals(Util.null2String(hrmResourceImportParam.getLocation_id()))) {
                            int locationid = getLocationId(hrmResourceImportParam.getLocation_id());
                            hrmResourcePO.setLocationId(locationid);
                        }

                        //邮箱-sunjsh
                        if (hrmResourceImportParam.getEmail() != null) {
                            if (!"".equals(hrmResourceImportParam.getEmail().trim()) && hrmResourceImportParam.getEmail().contains("*")) {
                                hrmResourceImportParam.setEmail(null);
                            } else if ("".equals(hrmResourceImportParam.getEmail().trim())) {
                                hrmResourcePO.setEmail("");
                            } else {
                                Pattern pattern = Pattern.compile("^([a-zA-Z\\d_\\-.]+)@((\\[\\d{1,3}\\.\\d{1,3}\\.\\d{1,3}\\.)|(([a-zA-Z\\d\\-]+\\.)+))([a-zA-Z]{2,4}|\\d{1,3})(]?)$");
                                Matcher matcher = pattern.matcher(hrmResourceImportParam.getEmail());
                                if (!matcher.matches()) {
                                    resultList.add(createLog(hrmResourceImportParam, "更新", "失败", SystemEnv.getHtmlLabelName(24570, userlanguage)));
                                    continue;
                                } else {
                                    hrmResourcePO.setEmail(hrmResourceImportParam.getEmail());
                                }
                            }
                        }

                        //mobile-sunjsh
                        if (hrmResourceImportParam.getMobile() != null) {
                            if ("".equals(hrmResourceImportParam.getMobile().trim())) hrmResourcePO.setMobile("");
                            else if (!"".equals(hrmResourceImportParam.getMobile().trim()) && hrmResourceImportParam.getMobile().contains("*"))
                                hrmResourceImportParam.setMobile(null);
                        }

                        //工资银行-sunjsh
                        if (hrmResourceImportParam.getBank_id() != null && !"".equals(hrmResourceImportParam.getBank_id())) {
                            org.json.JSONObject jsonObject = new org.json.JSONObject();
                            jsonObject.put("fieldid", 0);
                            jsonObject.put("fieldhtmltype", 3);
                            jsonObject.put("type", 284);
                            jsonObject.put("dmlurl", "");
                            jsonObject.put("fieldvalue", hrmResourceImportParam.getBank_id());

                            String fieldvalue = HrmFieldManager.getReallyFieldvalue(jsonObject);
                            if (!"".equals(fieldvalue)) {
                                hrmResourcePO.setBankId(new Integer(fieldvalue));
                            } else {
                                hrmResourcePO.setBankId(this.getBankId(hrmResourceImportParam.getBank_id()));
                            }
                        }

                        //sunjsh-入职日期
                        if (hrmResourceImportParam.getCompany_start_date() != null && !"".equals(hrmResourceImportParam.getCompany_start_date())) {
                            hrmResourcePO.setCompanyStartDate(hrmResourceImportParam.getCompany_start_date());
                        } else {
                            hrmResourceImportParam.setCompany_start_date(null);
                        }

                        //sunjsh-参加工作日期
                        if (hrmResourceImportParam.getWork_start_date() != null && !"".equals(hrmResourceImportParam.getWork_start_date())) {
                            hrmResourcePO.setWorkStartDate(hrmResourceImportParam.getWork_start_date());
                        } else {
                            hrmResourceImportParam.setWork_start_date(null);
                        }
                        // 职称
                        if (!"".equals(Util.null2String(hrmResourceImportParam.getJob_call()))) {
                            hrmResourcePO.setJobCall(getJobCall(hrmResourceImportParam.getJob_call()));
                        }
                        // 系统语言，默认简体中文
                        if (!"".equals(Util.null2String(hrmResourceImportParam.getSystem_language()))) {
                            int systemlanguage = getSystemLanguage(hrmResourceImportParam.getSystem_language());

                            if (systemlanguage == -1) {    //只能选择简体中文|Englisth|繁体中文
                                resultList.add(createLog(hrmResourceImportParam, "更新", "失败", SystemEnv.getHtmlLabelName(518929, userlanguage)));
                                continue;
                            }
                            //系统不支持多语言
                            if (systemlanguage == 0) {
                                resultList.add(createLog(hrmResourceImportParam, "更新", "失败", SystemEnv.getHtmlLabelName(84810, userlanguage)));
                                continue;
                            }
                            hrmResourcePO.setSystemLanguage(systemlanguage);
                        }

                        // 性别，为空或其他情况统一为0(男)
                        if (hrmResourceImportParam.getSex() == null) {
                            hrmResourcePO.setSex("0");
                        } else if (!"".equals(Util.null2String(hrmResourceImportParam.getSex()))) {
                            String sex = hrmResourceImportParam.getSex().equals("女") ? "1" : "0";
                            hrmResourcePO.setSex(sex);
                        }

                        // 婚姻状况，如果不是以下选项，则默认为未婚
                        if (!"".equals(Util.null2String(hrmResourceImportParam.getMarital_status()))) {
                            String maritalstatus = hrmResourceImportParam.getMarital_status().equals("已婚") ? "1" : hrmResourceImportParam.getMarital_status().equals("离异") ? "2" : "0";
                            hrmResourcePO.setMaritalStatus(maritalstatus);
                        }

                        // 员工状态
                        if (!"".equals(Util.null2String(hrmResourceImportParam.getStatus()))) {
                            int status = getStatus(hrmResourceImportParam.getStatus());
                            hrmResourcePO.setStatus(status);
                        } else {
                            hrmResourcePO.setStatus(0);
                        }

                        // 人员密级
                        if (!"".equals(Util.null2String(hrmResourceImportParam.getClassification()))) {
                            int classification = getClassification(hrmResourceImportParam.getClassification());
                            hrmResourcePO.setClassification(classification);
                        }

                        // 学历
                        if (!"".equals(Util.null2String(hrmResourceImportParam.getEducation_level()))) {
                            int educationlevel = getEducationLevel(hrmResourceImportParam.getEducation_level());
                            hrmResourcePO.setEducationLevel(educationlevel);
                        }

                        // 工会会员,默认为是
                        if (!"".equals(Util.null2String(hrmResourceImportParam.getIslabouunion()))) {
                            String islabouunion = hrmResourceImportParam.getIslabouunion().equals("是") ? "1" : "0";
                            hrmResourcePO.setIslabouunion(islabouunion);
                        }

                        // 健康状况
                        if (!"".equals(Util.null2String(hrmResourceImportParam.getHealth_info()))) {
                            String healthinfo = getHealthInfo(hrmResourceImportParam.getHealth_info());
                            hrmResourcePO.setHealthInfo(healthinfo);
                        }

                        //安全级别不能大于999
                        if (Util.getIntValue(hrmResourceImportParam.getSec_level(), 0) > 999) {
                            resultList.add(createLog(hrmResourceImportParam, "更新", "失败", SystemEnv.getHtmlLabelName(515522, userlanguage)));
                            continue;
                        }
                        //安全级别不能小于-999
                        if (Util.getIntValue(hrmResourceImportParam.getSec_level(), 0) < -999) {
                            resultList.add(createLog(hrmResourceImportParam, "更新", "失败", SystemEnv.getHtmlLabelName(515523, userlanguage)));
                            continue;
                        }
                        //安全级别必须是数字
                        if (!Util.null2String(hrmResourceImportParam.getSec_level()).equals("")) {
                            if (Util.getIntValue(hrmResourceImportParam.getSec_level(), -1000) == -1000) {
                                resultList.add(createLog(hrmResourceImportParam, "更新", "失败", "安全级别必须是数字"));
                                continue;
                            } else {
                                hrmResourcePO.setSecLevel(Util.getIntValue(hrmResourceImportParam.getSec_level()));
                            }
                        }

                        //职级
                        if (isInteger(hrmResourceImportParam.getJob_level())) {
                            int joblevel = hrmResourceImportParam.getJob_level().equals("") ? 0 : Integer.parseInt(hrmResourceImportParam.getJob_level());
                            hrmResourcePO.setJobLevel((long) joblevel);
                        }

                        // 职务分类
                        Long jobGroupId = null;
                        if (hrmResourceImportParam.getJob_group_id() != null) {
                            List<PostPO> postPOS = getPostMapper().listByName(hrmResourceImportParam.getJob_group_id());
                            if (CollectionUtils.isNotEmpty(postPOS)) {
                                jobGroupId = postPOS.get(0).getId();
                            } else {
                                PostPO postPO = PostPO.builder()
                                        .postName(hrmResourceImportParam.getJob_group_id())
                                        .creator((long) user.getUID())
                                        .deleteType(0)
                                        .createTime(new Date())
                                        .build();
                                getPostMapper().insertIgnoreNull(postPO);
                                jobGroupId = postPO.getId();
                            }
                            hrmResourcePO.setJobGroupId(jobGroupId);
                        }

                        // 职务
                        if (hrmResourceImportParam.getJob_activity() != null) {
                            if (null == jobGroupId) {
                                resultList.add(createLog(hrmResourceImportParam, "创建", "失败", "职务导入错误，未找到对应职务类别"));
                                continue;
                            }
                            PostInfoPO postInfoPO = getPostInfoMapper().getPostInfoByNameAndPostId(hrmResourceImportParam.getJob_activity(), jobGroupId);
                            if (null == postInfoPO) {
                                postInfoPO = PostInfoPO.builder()
                                        .postInfoNo(hrmResourceImportParam.getJob_activity())
                                        .postInfoName(hrmResourceImportParam.getJob_activity())
                                        .postId(jobGroupId)
                                        .creator((long) user.getUID())
                                        .deleteType(0)
                                        .createTime(new Date())
                                        .build();
                                getPostInfoMapper().insertIgnoreNull(postInfoPO);
                            }
                            hrmResourcePO.setJobActivity(postInfoPO.getId());
                        }

                        //用工性质
                        if (hrmResourceImportParam.getUse_kind() != null) {
                            int usekind = getUseKind(hrmResourceImportParam.getUse_kind());
                            hrmResourcePO.setUseKind(usekind);
                        }

                        // 手机 办公电话
                        CheckItemBean mobileBean = new CheckItemBean("mobile", hrmResourceImportParam.getMobile());
                        ValidateFieldManager.validate(mobileBean);
                        if (!mobileBean.isPass()) {
                            resultList.add(createLog(hrmResourceImportParam, "更新", "失败", mobileBean.getCheckMsg()));
                            continue;
                        }
                        CheckItemBean telephoneBean = new CheckItemBean("telephone", hrmResourceImportParam.getTelephone());
                        ValidateFieldManager.validate(telephoneBean);
                        if (!telephoneBean.isPass()) {
                            resultList.add(createLog(hrmResourceImportParam, "更新", "失败", telephoneBean.getCheckMsg()));
                            continue;
                        }


                        //密码 加密
                        if (!"".equals(Util.null2String(hrmResourceImportParam.getPass_word()))) {

                            String orgPwd = "1";
                            if (!"".equals(hrmResourceImportParam.getPass_word()))
                                orgPwd = hrmResourceImportParam.getPass_word();
                            String[] pwdArr = PasswordUtil.encrypt(orgPwd);
                            String salt = pwdArr[1];
                            hrmResourcePO.setPassWord(pwdArr[0]);

                            PasswordUtil.updateResourceSalt(keyMap.get(key) + "", salt);
                            HrmFaceCheckManager.setUserPassowrd(keyMap.get(key) + "", orgPwd);

                        }
                        Map<String, Object> resourceParams = new HashMap<>();

                        for (int k = 1; k < fields.length; k++) {
                            Field hrmField = resourcePOClass.getDeclaredField(PageInfoSortUtil.underlineToHump(fields[k]));
                            Field paramClassDeclaredField = importParamClass.getDeclaredField(fields[k]);

                            String hrmFieldType = hrmField.getType().getName();
                            String voFieldType = paramClassDeclaredField.getType().getName();

                            hrmField.setAccessible(true);
                            paramClassDeclaredField.setAccessible(true);

                            if (Util.null2String(hrmField.get(hrmResourcePO)).trim().length() > 0) {
                                if (hrmFieldType.endsWith("String")) {
                                    resourceParams.put(fields[k], hrmField.get(hrmResourcePO));
                                } else if (hrmFieldType.endsWith("Long") || hrmFieldType.endsWith("Integer") || hrmFieldType.endsWith("Short") || hrmFieldType.endsWith("Float")) {
                                    resourceParams.put(fields[k], hrmField.get(hrmResourcePO));
                                }
                            } else if (Util.null2String(paramClassDeclaredField.get(hrmResourceImportParam)).trim().length() > 0) {
                                if (voFieldType.endsWith("String")) {
                                    if (Util.null2String(paramClassDeclaredField.get(hrmResourceImportParam)).equals("")) {
                                        resourceParams.put(fields[k], null);
                                    } else {
                                        resourceParams.put(fields[k], paramClassDeclaredField.get(hrmResourceImportParam));
                                    }
                                } else if (voFieldType.endsWith("Long") || voFieldType.endsWith("Integer") || voFieldType.endsWith("Short") || voFieldType.endsWith("Float")) {
                                    if (voFieldType.endsWith("Integer") && (paramClassDeclaredField.get(hrmResourceImportParam).equals(0x7fffffff))) {
                                        resourceParams.put(fields[k], null);
                                    } else {
                                        resourceParams.put(fields[k], paramClassDeclaredField.get(hrmResourceImportParam));
                                    }
                                }
                            }
                        }
                        resourceParams.put("update_time", DateUtil.getCurrentDate());
                        ExtendInfoParams infoParams = ExtendInfoParams.builder().id((long) keyMap.get(key)).tableName("jcl_org_hrmresource").params(resourceParams).build();
                        getExtMapper().updateExt(infoParams);
                    }
                } catch (Exception e) {
                    //数据异常
                    new BaseBean().writeLog(e);
                }
            }
            try {
                HrmTlevelManager.setUpdate();
            } catch (Exception e) {
                new BaseBean().writeLog(e);
            }

            Map<String, Object> params = new HashMap<>();
            params.put("pId", this.pId);
            params.put("status", "over");
            importLogService.saveImportLogStatus(params, user);

        } catch (Exception e) {
            new BaseBean().writeLog(e);
            Map<String, Object> params = new HashMap<>();
            params.put("pId", this.pId);
            params.put("status", "error");
            importLogService.saveImportLogStatus(params, user);
        }
    }


    /**
     * 根据分部名称获取分部Id，不存在就创建
     *
     * @param subCompanyName 分部名称 eg：泛微广东>泛微深圳
     */
    public Long getSubCompanyId(String subCompanyName) {

        String[] subCompanyNames = subCompanyName.split(">");
        if (subCompanyNames.length >= 10) {
            return -9L;
        }
        long currentId = 0L;
        long parentId = 0L;
        int curCount = 0;

        for (String companyName : subCompanyNames) {
            if (StringUtil.isNull(companyName)) {
                continue;
            }

            Long companyId = getCompMapper().getIdByNameAndPid(companyName.trim(), parentId);
            currentId = null == companyId ? 0 : companyId;

            if (parentId == 0 && currentId == 0) {
                curCount = getCompMapper().countTopCompany(0L);

            }

            //added by wcd 2015-02-06 [限制分部数]
            if (currentId == 0) {
                if (scCount == 0 || curCount < scCount) {
                    // 如果编码为空 自动生成编码
                    String compNo = "";
                    try {
                        compNo = CodeRuleManager.getCodeRuleManager().generateRuleCode(RuleCodeType.SUBCOMPANY, compNo);
                    } catch (Exception e) {
                        new BaseBean().writeLog(e);
                    }
                    CompPO compPO = CompPO.builder()
                            .compNo(compNo)
                            .compName(companyName.trim())
                            .compNameShort(companyName.trim())
                            .parentCompany(0 == parentId ? null : parentId)
                            .creator((long) user.getUID())
                            .deleteType(0)
                            .createTime(new Date())
                            .build();
                    getCompMapper().insertIgnoreNull(compPO);
                    currentId = compPO.getId().intValue();

                } else {
                    currentId = -1;
                }
            }
            parentId = currentId;
        }
        return currentId;
    }

    /**
     * 获取部门id，不存在就创建
     *
     * @param deptNames 部门名称
     * @param companyId 所属分部id
     */
    public Long getDeptId(String deptNames, long companyId) {

        String[] deptNameArray = deptNames.split(">");
        long currentId = 0L;
        long parentId = 0L;

        for (String deptName : deptNameArray) {
            if (deptName == null || deptName.equals("")) {
                continue;
            }
            Long departmentId = getDepartmentMapper().getIdByNameAndPid(deptName.trim(), companyId, parentId);
            currentId = null == departmentId ? 0 : departmentId;

            if (currentId == 0) {
                // 如果编码为空 自动生成编码
                String deptNo = "";
                try {
                    deptNo = CodeRuleManager.getCodeRuleManager().generateRuleCode(RuleCodeType.DEPARTMENT, deptNo);
                } catch (Exception e) {
                    new BaseBean().writeLog(e);
                }
                DepartmentPO departmentPO = DepartmentPO.builder()
                        .deptNo(deptNo)
                        .deptName(deptName.trim())
                        .deptNameShort(deptName.trim())
                        .parentComp(0 == companyId ? null : companyId)
                        .parentDept(0 == parentId ? null : parentId)
                        .forbiddenTag(0)
                        .creator((long) user.getUID())
                        .deleteType(0)
                        .createTime(new Date())
                        .build();
                getDepartmentMapper().insertIgnoreNull(departmentPO);
                currentId = departmentPO.getId().intValue();
            }
            parentId = currentId;
        }
        return currentId;
    }

    public Long getJobTitles(Long companyId, Long departmentId, String jobNames) {


        String[] jobNameArray = jobNames.split(">");
        long currentId = 0L;
        long parentId = 0L;

        for (String jobName : jobNameArray) {
            if (jobName == null || jobName.equals("")) {
                continue;
            }
            Long jobId = getJobMapper().getIdByNameAndPid(jobName.trim(), companyId, departmentId, parentId);
            currentId = null == jobId ? 0 : jobId;
            if (currentId == 0) {
                // 如果编码为空 自动生成编码
                String jobNo = "";
                try {
                    jobNo = CodeRuleManager.getCodeRuleManager().generateRuleCode(RuleCodeType.JOBTITLES, jobNo);
                } catch (Exception e) {
                    new BaseBean().writeLog(e);
                }
                JobPO jobPO = JobPO.builder()
                        .jobNo(jobNo)
                        .jobName(jobName)
                        .parentComp(0 == companyId ? null : companyId)
                        .parentDept(0 == departmentId ? null : departmentId)
                        .parentJob(0 == parentId ? null : parentId)
                        .forbiddenTag(0)
                        .creator((long) user.getUID())
                        .deleteType(0)
                        .createTime(new Date())
                        .build();
                getJobMapper().insertIgnoreNull(jobPO);
                currentId = jobPO.getId();
            }
            parentId = currentId;
        }
        return currentId;
    }


    /**
     * 获取直接上级Id和所有上级
     *
     * @param keyFieldValue 上级标记值，eg:编号
     * @param keyField      关键字段
     */
    public int getManagerId(String keyFieldValue, String keyField) {

        int managerId = 0;
        if (!keyFieldValue.equals("")) {
            Integer userId = getResourceMapper().getIdByKeyField(keyField, keyFieldValue);
            managerId = null == userId ? 0 : userId;
        }
        return managerId;
    }

    /**
     * 获取助理id
     *
     * @param keyFieldValue 助理标记
     * @param keyField      关键字段
     */
    public int getAssistantId(String keyFieldValue, String keyField) {
        return getResourceId(keyFieldValue, keyField, 0);
    }

    private int getResourceId(String keyFieldValue, String keyField, int resourceId) {
        if (!keyFieldValue.equals("")) {
            Integer userId = getResourceMapper().getIdByKeyField(keyField, keyFieldValue);
            resourceId = null == userId ? 0 : userId;
        }
        return resourceId;
    }

    /**
     * 获取主账号id
     *
     * @param keyFieldValue 主账号标记
     * @param keyField      关键字段
     */
    public Long getBelongId(String keyFieldValue, String keyField) {
        return (long) getResourceId(keyFieldValue, keyField, -1);
    }

    /**
     * 办公地点id
     *
     * @param locationName 办公地点名称
     */
    public int getLocationId(String locationName) {
        int locationId = 0;
        if (!locationName.equals("")) {
            locationId = locationMap.getOrDefault(locationName, 0);
            if (locationId == 0) {
                Map<String, Object> hrmLocationsMap = new HashMap<>();
                hrmLocationsMap.put("locationname", locationName);
                hrmLocationsMap.put("locationdesc", locationName);
                hrmLocationsMap.put("countryid", 1);
                ExtendInfoParams extendInfoParams = ExtendInfoParams.builder().params(hrmLocationsMap).tableName("HrmLocations").build();
                getExtMapper().insertExt(extendInfoParams);
                locationId = extendInfoParams.getId().intValue();
                locationMap.put(locationName, locationId);
            }
        }
        return locationId;
    }

    /**
     * 用工性质id
     *
     * @param useKindName 用工性质名称
     */
    public int getUseKind(String useKindName) {
        int usekindid = 0;
        if (!useKindName.equals("")) {
            usekindid = usekindMap.getOrDefault(useKindName, 0);
            if (usekindid == 0) {
                Map<String, Object> hrmUseKindMap = new HashMap<>();
                hrmUseKindMap.put("name", useKindName);
                hrmUseKindMap.put("description", useKindName);
                ExtendInfoParams extendInfoParams = ExtendInfoParams.builder().params(hrmUseKindMap).tableName("HrmUseKind").build();
                getExtMapper().insertExt(extendInfoParams);
                usekindid = extendInfoParams.getId().intValue();
                usekindMap.put(useKindName, usekindid);
            }
        }
        return usekindid;
    }

    /**
     * 职称
     *
     * @param jobCall 职称名称
     */
    public int getJobCall(String jobCall) {
        int jobCallId = 0;
        if (!jobCall.equals("")) {
            jobCallId = jobcallMap.getOrDefault(jobCall, 0);
            if (jobCallId == 0) {
                Map<String, Object> hrmJobCallMap = new HashMap<>();
                hrmJobCallMap.put("name", jobCall);
                ExtendInfoParams extendInfoParams = ExtendInfoParams.builder().params(hrmJobCallMap).tableName("HrmJobCall").build();
                getExtMapper().insertExt(extendInfoParams);
                jobCallId = extendInfoParams.getId().intValue();
                jobcallMap.put(jobCall, jobCallId);
            }
        }
        return jobCallId;
    }

    /**
     * 系统语言
     *
     * @param language 语言 eg：简体中文,English,繁體中文
     */
    public int getSystemLanguage(String language) {
        int systemlanguageid = 7;  //系统语言默认为中文
        //如果系统不支持多语言，则返回0
        if ((language.equals("English") || language.equals("繁體中文")) && !multilanguage.equalsIgnoreCase("y")) {
            return 0;
        }
        if (!language.equals("")) {
            if (language.equals("简体中文")) {
                systemlanguageid = cnLanguageId;
            } else {
                systemlanguageid = sysLanguage.getOrDefault(language, -1);
            }
        }
        return systemlanguageid;
    }

    /**
     * 工资银行id
     *
     * @param bank 办公地点名称
     */
    public int getBankId(String bank) {
        int id = 0;
        if (!bank.equals("")) {
            Map<String, Object> hrmBankMap = new HashMap<>();
            hrmBankMap.put("bankname", bank);
            hrmBankMap.put("bankdesc", bank);
            ExtendInfoParams extendInfoParams = ExtendInfoParams.builder().params(hrmBankMap).tableName("hrmbank").build();
            getExtMapper().insertExt(extendInfoParams);
            id = extendInfoParams.getId().intValue();
        }
        return id;
    }

    /**
     * 获取员工状态
     *
     * @param status 员工状态值
     */
    public int getStatus(String status) {
        int statusId;
        switch (status) {
            case "试用":
                statusId = 0;
                break;
            case "临时":
                statusId = 2;
                break;
            case "试用延期":
                statusId = 3;
                break;
            case "解聘":
                statusId = 4;
                break;
            case "离职":
                statusId = 5;
                break;
            case "退休":
                statusId = 6;
                break;
            case "无效":
                statusId = 7;
                break;
            default:
                statusId = 1;
                break;
        }
        return statusId;
    }

    /**
     * 获取人员密级
     */
    public int getClassification(String classification) {

        int classificationId;
        switch (classification) {
            case "核心":
                classificationId = 0;
                break;
            case "重要":
                classificationId = 1;
                break;
            case "一般":
                classificationId = 2;
                break;
            default:
                classificationId = 3;
                break;
        }
        return classificationId;
    }

    /**
     * 获取学历Id
     *
     * @param educationLevel 学历值
     */
    public int getEducationLevel(String educationLevel) {
        int educationLevelId = 0;
        if (!educationLevel.equals("")) {
            educationLevelId = educationlevelMap.getOrDefault(educationLevel, 0);
            if (educationLevelId == 0) {
                Map<String, Object> hrmEducationLevelMap = new HashMap<>();
                hrmEducationLevelMap.put("name", educationLevel);
                hrmEducationLevelMap.put("description", educationLevel);
                ExtendInfoParams extendInfoParams = ExtendInfoParams.builder().params(hrmEducationLevelMap).tableName("HrmEducationLevel").build();
                getExtMapper().insertExt(extendInfoParams);
                educationLevelId = extendInfoParams.getId().intValue();
                educationlevelMap.put(educationLevel, educationLevelId);
            }
        }
        return educationLevelId;
    }

    /**
     * 获取身体状况
     */
    public String getHealthInfo(String healthInfo) {
        String healthInfoId;
        switch (healthInfo) {
            case "良好":
                healthInfoId = "1";
                break;
            case "一般":
                healthInfoId = "2";
                break;
            case "较差":
                healthInfoId = "3";
                break;
            default:
                healthInfoId = "0";
                break;
        }
        return healthInfoId;
    }

    /**
     * 获取id与workcode_lastname 键值对，用于对导入数据重复性判断
     *
     * @param keyField key值，重复性验证字段
     */
    public void getKeyMap(String keyField) {
        List<JSONObject> keyMaps = getResourceMapper().getKeyMapByKetField(keyField);
        String cerNum;
        for (JSONObject map : keyMaps) {
            {
                for (String key : checkKeys) {
                    Map<String, String> checkInfo = checkInfos.get(key);
                    if (checkInfo == null) {
                        checkInfo = new HashMap<>();
                        checkInfos.put(key, checkInfo);
                    } else {
                        checkInfo = checkInfos.get(key);
                    }
                    String val = Util.null2String(map.getString(key));
                    checkInfo.put(val, map.getString("id"));
                    checkInfos.put(key, checkInfo);
                }

                cerNum = map.getString("certificate_num");
                keyMap.put(map.getString(keyField), map.getInteger("id"));
                String accountType = map.getString("account_type");
                if (!"1".equalsIgnoreCase(accountType)) {
                    if (StringUtil.isNotNull(cerNum)) {
                        certificateNums.put(StringUtil.vString(cerNum), map.getInteger("id"));
                    }
                }
            }
        }

    }

    /**
     * 执行插入操作
     */

    public boolean execSql(String sql) {
        RecordSet recordSet = new RecordSet();
        return recordSet.execute(sql);
    }

    /**
     * 创建日志对象
     *
     * @param importParam HrmResourceVo  人员信息对象
     * @param operation   操作类型  验证|创建|更新
     * @param status      状态 成功|失败
     * @param reason      失败原因
     * @return ImportLog对象
     */
    public ImportLog createLog(HrmResourceImportParam importParam, String operation, String status, String reason) {
        ImportLog log = new ImportLog();

        log.setWorkCode(importParam.getWork_code());  //编号
        log.setLastname(importParam.getLast_name());  //用户名
        log.setLoginid(importParam.getLogin_id());    //登录名
        log.setOperation(operation);        //操作类型
        if (importParam.getCompany_id() != null && importParam.getDepartment_id() != null)
            log.setDepartment(importParam.getCompany_id() + ">" + importParam.getDepartment_id()); //分部部门
        else log.setDepartment("");
        log.setStatus(status);              //状态，成功、失败
        log.setReason(reason);              //原因

        try {
            ImportLogService importLogService = ServiceUtil.getService(ImportLogServiceImpl.class, user);
            String relatedName = "";
            switch (this.keyField) {
                case "work_code":
                    relatedName = log.getWorkCode();
                    break;
                case "login_id":
                    relatedName = log.getLoginid();
                    break;
                case "last_name":
                    relatedName = log.getLastname();
                    break;
            }

            Map<String, Object> params = new HashMap<>();
            params.put("pId", this.pId);
            params.put("lineNum", this.rowNum + 2);//修正偏移量错误
            params.put("relatedName", relatedName);
            params.put("msg", log.getStatus().equals("成功") ? relatedName + "导入成功！" : log.getReason());
            params.put("status", log.getStatus().equals("成功") ? "1" : "0");
            importLogService.saveImportDeitalLog(params, user);
        } catch (Exception e) {
            new BaseBean().writeLog(e);
        }
        return log;
    }

    //整数判断
    public static boolean isInteger(String str) {
        if (str == null) return false;
        Pattern pattern = Pattern.compile("\\d+");
        return pattern.matcher(str).matches();
    }


    private boolean checkInfo(HrmResourceImportParam importParam, List<ImportLog> resultList) {
        //新增账号、工号唯一性校验
        for (String key : checkKeys) {
            Map<String, String> checkInfo = checkInfos.get(key);
            if (checkInfo != null && !checkInfo.isEmpty()) {
                String val = "";
                String errorMsg = "";
                switch (key) {
                    case "login_id":
                        val = Util.null2String(importParam.getLogin_id()).trim();
                        errorMsg = SystemEnv.getHtmlLabelName(522076, userlanguage);
                        break;
                    case "work_code":
                        val = Util.null2String(importParam.getWork_code()).trim();
                        errorMsg = SystemEnv.getHtmlLabelName(520197, userlanguage);
                        break;
                    case "certificate_num":
                        val = Util.null2String(importParam.getCertificate_num()).trim();
                        errorMsg = SystemEnv.getHtmlLabelName(83521, userlanguage);
                        break;
                }
                int reosurceid = Util.getIntValue(checkInfo.get(val));
                if (importParam.getId() != null && importParam.getId() == reosurceid) {
                    //如果是当前记录，不需要校验
                    continue;
                }

                if (reosurceid > 0 && val.length() > 0) {
                    resultList.add(createLog(hrmResourceImportParam, this.operateType.equals("add") ? "创建" : "更新", "失败", errorMsg));
                    return true;
                }
            }
        }
        return false;
    }

}
