package com.engine.organization.wrapper;

import com.engine.common.util.ServiceUtil;
import com.engine.organization.annotation.Log;
import com.engine.organization.entity.po.Demo;
import com.engine.organization.enums.OperateTypeEnum;
import com.engine.organization.service.DemoService;
import com.engine.organization.service.impl.DemoServiceImpl;
import com.engine.organization.util.OrganizationWrapper;
import com.engine.organization.util.response.ReturnResult;
import weaver.hrm.User;

import java.util.List;

/**
 * @Author weaver_cl
 * @description:
 * @Date 2022/4/26
 * @Version V1.0
 **/
public class DemoWrapper extends OrganizationWrapper {

    private DemoService getDemoService(User user) {
        return ServiceUtil.getService(DemoServiceImpl.class, user);
    }

    @Log(operateType = OperateTypeEnum.DELETE, operateDesc = "operateDesc")
    public ReturnResult testDemo(String name) {
        List<Demo> list = getDemoService(user).list(name);
        writeOperateLog(new Object(){}.getClass(), "记录testDemo操作日志");
        return ReturnResult.successed(list);
    }
}
